//INIT
//"Required plugins should automatically set themselves to required"
global.serverPluginsRequired=1

//Write/read settings from ini
ini_open("gg2.ini")
    global.turkeyLimit=ini_read_real("Plugins","turkeyLimit",30)
    ini_write_real("Plugins","turkeyLimit",global.turkeyLimit)
ini_close()

//EXECUTE EXTRA FILES
execute_file(directory+"\loadFiles.gml");
execute_file(directory+"\objects.gml");
execute_file(directory+"\projectileMods.gml");
execute_file(directory+"\turkeys.gml");
execute_file(directory+"\netcode.gml");
;
//MAP CODE
//Read custom entities
object_event_add(RoomChangeObserver, ev_other, ev_room_start, '
//Place a generator on the map to indicate ctt mode
if instance_exists(Generator){
var leveldata, tempfile;
tempfile = temp_directory+"\custommap_walkmask.png";
leveldata = GG2DLL_extract_PNG_leveldata("Maps/" + global.currentMap + ".png", tempfile);

if(leveldata == "") break;

// handle the leveldata
var entityString, walkmaskString, walkmaskSurface, currentPos, entityType, entityX, entityY, wordLength, DIVREPLACEMENT;
var a, b, entity;
var ENTITYTAG, ENDENTITYTAG, DIVIDER;
ENTITYTAG = "{ENTITIES}";
ENDENTITYTAG = "{END ENTITIES}";
DIVIDER = chr(10);
DIVREPLACEMENT = " ";

// grab the entity data
a = string_pos(ENTITYTAG, leveldata);
b = string_pos(ENDENTITYTAG, leveldata);
if(a == 0 || b == 0) break;
entityString = string_copy(leveldata, a + string_length(ENTITYTAG) + string_length(DIVIDER), b - a - string_length(ENTITYTAG) - string_length(DIVIDER) - 1) + DIVIDER;

currentPos = 1;

while(string_pos(DIVIDER, entityString) != 0) { // continue until there are no more entities left
    // grab the entity type
    wordLength = string_pos(DIVIDER, entityString) - currentPos;
    entityType = string_copy(entityString, currentPos, wordLength);
    entityString = string_replace(entityString, DIVIDER, DIVREPLACEMENT);
    currentPos += wordLength + string_length(DIVREPLACEMENT);
    // grab the x coordinate
    wordLength = string_pos(DIVIDER, entityString) - currentPos;
    entityX = real(string_copy(entityString, currentPos, wordLength));
    entityString = string_replace(entityString, DIVIDER, DIVREPLACEMENT);
    currentPos += wordLength + string_length(DIVREPLACEMENT);
    // grab the y coordinate
    wordLength = string_pos(DIVIDER, entityString) - currentPos;
    entityY = real(string_copy(entityString, currentPos, wordLength));
    entityString = string_replace(entityString, DIVIDER, DIVREPLACEMENT);
    currentPos += wordLength + string_length(DIVREPLACEMENT);

    switch(entityType){
        case "TurkeySpawn":
            instance_create(entityX, entityY, TurkeySpawn)
        break;
        case "TurkeyPenRed":
            instance_create(entityX, entityY, TurkeyPenRed)
        break;
        case "TurkeyPenBlue":
            instance_create(entityX, entityY, TurkeyPenBlue)
        break;
    }
    if instance_exists(TurkeySpawn){
        instance_create(0,0,CTTHUD)
        with(GeneratorHUD){
            instance_destroy()
        }
    }
}
}
');

//MODIFY EXISTING OBJECTS
object_event_add(Player,ev_other,ev_user12,'
with(Turkey){
    event_user(12)
}
')

object_event_add(Player,ev_other,ev_user13,'
with(Turkey){
    event_user(13)
}
')

object_event_add(Character,ev_create,0,'
    turkeyCarryingWeight=0
')

object_event_add(Character,ev_step,ev_step_begin,'
//Drop turkey when bubble
if keyboard_check_pressed(global.drop){
    write_ubyte(global.serverSocket,CHAT_BUBBLE)
    write_ubyte(global.serverSocket,61)
}
')

object_event_add(SpeechBubbleO,ev_step,ev_step_begin,'
if image_index==61{
    with(Turkey){
        if carryingPlayer==other.owner{
            event_user(10)
        }
    }
    fadeout=true
    if bubbleAlpha==0 and image_index==61{
        image_index+=1
    }
}
')